// SCOPE 1
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _32
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 1, std430) restrict readonly buffer _34_36
{
    _32 _m0[];
} _36;

layout(set = 2, binding = 0, std140) uniform _78_80
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _80;

layout(set = 0, binding = 0, std140) uniform _90_92
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _92;

layout(set = 1, binding = 0, std140) uniform _144_146
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _146;

layout(set = 0, binding = 2, std430) restrict readonly buffer _361_363
{
    vec4 _m0[];
} _363;

layout(push_constant, std430) uniform _39_41
{
    int _m0;
    int _m1;
} _41;

layout(set = 0, binding = 3) uniform sampler _1608;

layout(location = 0) in vec4 _68;
layout(location = 3) in vec4 _129;
layout(location = 9) in vec4 _381;
layout(location = 2) in vec4 _397;
layout(location = 1) in vec2 _556;
layout(location = 12) in vec2 _558;
layout(location = 2) out vec4 _566;
layout(location = 14) flat out uvec3 _573;
layout(location = 10) out vec4 _1085;
layout(location = 11) out vec4 _1600;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

void main()
{
    vec4 _31 = _36._m0[_41._m1]._m0;
    vec4 _49 = _36._m0[_41._m1]._m1;
    vec4 _54 = _36._m0[_41._m1]._m2;
    vec4 _60 = _36._m0[_41._m1]._m3;
    vec4 _66 = vec4(_68.xyz, 1.0);
    bool _87 = _80._m0.x != 0.0;
    bool _98;
    if (_87)
    {
        _98 = _92._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _98 = _87;
    }
    bool _104;
    if (_98)
    {
        _104 = _80._m1.x > 0.0;
    }
    else
    {
        _104 = _98;
    }
    if (_104)
    {
        vec3 _108 = vec3(_92._m0.xy, 0.0);
        float _117 = _80._m0.x;
        float _120 = _80._m0.y;
        float _124 = _80._m0.w;
        vec4 _128 = _129;
        float _131 = _80._m1.x;
        float _134 = _80._m1.y;
        float _137 = _80._m1.z;
        float _140 = _80._m1.w;
        vec4 _147 = _66;
        vec4 _149 = _146._m0;
        vec4 _143;
        _143.x = _12(_147, _149);
        vec4 _154 = _66;
        vec4 _156 = _146._m1;
        _143.y = _12(_154, _156);
        vec4 _161 = _66;
        vec4 _163 = _146._m2;
        _143.z = _12(_161, _163);
        _143.w = 1.0;
        float _169 = dot(_143.xyz, _108) * _131;
        float _176 = _128.z * _140;
        float _181 = _146._m0.w * _146._m1.w;
        float _187 = ((_92._m1.x * _80._m0.z) * _131) - _169;
        float _197 = (_128.x * 1.0) - _176;
        float _203 = sin(_187 - _197);
        float _208 = sin((_187 * 1.33000004291534423828125) - _197);
        float _215 = ((_203 + _208) * 0.25) + 0.5;
        _215 *= _215;
        float _226 = (_215 * (_120 - _117)) + _117;
        vec3 _234 = _108 * vec3(_226);
        float _239 = ((_128.y * 16.0) - _181) - _176;
        float _248 = sin(((_92._m1.x * 4.0) * _134) + _239);
        float _258 = cos(((_92._m1.x * 3.3299999237060546875) * _134) + _239);
        float _268 = (_248 + _258) * (-_128.w);
        vec3 _276 = vec3(_248 * _124, _258 * _124, _268 * _137) * vec3(_226);
        vec3 _290 = ((_234 + _276) * _92._m0.z) * _128.z;
        vec3 _303 = _143.xyz + _290;
        _143 = vec4(_303.x, _303.y, _303.z, _143.w);
        _143.w = 1.0;
        _66.x = dot(_143, _146._m3);
        _66.y = dot(_143, _146._m4);
        _66.z = dot(_143, _146._m5);
    }
    if (_80._m2.z != 0.0)
    {
        vec4 _329 = _66;
        vec4 _331 = vec4(0.0);
        vec4 _333 = vec4(0.0);
        vec4 _334 = vec4(0.0);
        uvec4 _337 = uvec4(uint(_146._m6.x + _80._m2.x)) + uvec4(_129 * 255.0);
        if (_80._m2.z == 1.0)
        {
            uint _357 = _337.x;
            _331 = _363._m0[(_357 * 3u) + 0u];
            _333 = _363._m0[(_357 * 3u) + 1u];
            _334 = _363._m0[(_357 * 3u) + 2u];
        }
        else
        {
            float _380 = _381.w * 255.100006103515625;
            vec4 _387;
            _387.y = _380 - (floor(_380 / 128.0) * 128.0);
            float _396 = _397.w * 255.100006103515625;
            _387.z = floor(_396 / 16.0);
            _387.w = _396 - (_387.z * 16.0);
            _387.y *= 0.00393700785934925079345703125;
            _387.z *= 0.02222222276031970977783203125;
            _387.w *= 0.01666666753590106964111328125;
            _387.x = 1.0 - ((_387.y + _387.z) + _387.w);
            for (uint _436 = 0u; _436 < 4u; _436++)
            {
                _331 += (_363._m0[(_337[_436] * 3u) + 0u] * _387[_436]);
            }
            for (uint _460 = 0u; _460 < 4u; _460++)
            {
                _333 += (_363._m0[(_337[_460] * 3u) + 1u] * _387[_460]);
            }
            for (uint _483 = 0u; _483 < 4u; _483++)
            {
                _334 += (_363._m0[(_337[_483] * 3u) + 2u] * _387[_483]);
            }
        }
        vec4 _506 = _329;
        vec4 _508 = _331;
        _66.x = _12(_506, _508);
        vec4 _512 = _329;
        vec4 _514 = _333;
        _66.y = _12(_512, _514);
        vec4 _518 = _329;
        vec4 _520 = _334;
        _66.z = _12(_518, _520);
        _66.w = 1.0;
    }
    vec4 _529 = _66;
    vec4 _531 = _31;
    gl_Position.x = _12(_529, _531);
    vec4 _536 = _66;
    vec4 _538 = _49;
    gl_Position.y = _12(_536, _538);
    vec4 _542 = _66;
    vec4 _544 = _54;
    gl_Position.z = _12(_542, _544);
    vec4 _548 = _66;
    vec4 _550 = _60;
    gl_Position.w = _12(_548, _550);
    vec4 _554 = vec4(_556, _558);
    _566 = _554 + _80._m3;
    _573 = uvec3(0u);
    mat4 _575 = mat4(vec4(_146._m0), vec4(_146._m1), vec4(_146._m2), vec4(_146._m7));
    mat4 _606 = mat4(vec4(_92._m2), vec4(_92._m3), vec4(_92._m4), vec4(_92._m5));
    mat4 _637 = _575;
    mat4 _639 = _606;
    mat4 _636 = _19(_637, _639);
    vec4 _642 = _636[0];
    vec4 _645 = _636[1];
    vec4 _648 = _636[2];
    vec4 _651 = _636[3];
    vec4 _654 = vec4(_68.xyz, 1.0);
    bool _663 = _80._m0.x != 0.0;
    bool _669;
    if (_663)
    {
        _669 = _92._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _669 = _663;
    }
    bool _675;
    if (_669)
    {
        _675 = _80._m1.x > 0.0;
    }
    else
    {
        _675 = _669;
    }
    if (_675)
    {
        vec3 _678 = vec3(_92._m0.xy, 0.0);
        float _685 = _80._m0.x;
        float _688 = _80._m0.y;
        float _691 = _80._m0.w;
        vec4 _694 = _129;
        float _696 = _80._m1.x;
        float _699 = _80._m1.y;
        float _702 = _80._m1.z;
        float _705 = _80._m1.w;
        vec4 _709 = _654;
        vec4 _711 = _146._m0;
        vec4 _708;
        _708.x = _12(_709, _711);
        vec4 _716 = _654;
        vec4 _718 = _146._m1;
        _708.y = _12(_716, _718);
        vec4 _723 = _654;
        vec4 _725 = _146._m2;
        _708.z = _12(_723, _725);
        _708.w = 1.0;
        float _731 = dot(_708.xyz, _678) * _696;
        float _738 = _694.z * _705;
        float _743 = _146._m0.w * _146._m1.w;
        float _749 = ((_92._m1.x * _80._m0.z) * _696) - _731;
        float _759 = (_694.x * 1.0) - _738;
        float _765 = sin(_749 - _759);
        float _770 = sin((_749 * 1.33000004291534423828125) - _759);
        float _776 = ((_765 + _770) * 0.25) + 0.5;
        _776 *= _776;
        float _785 = (_776 * (_688 - _685)) + _685;
        vec3 _793 = _678 * vec3(_785);
        float _798 = ((_694.y * 16.0) - _743) - _738;
        float _806 = sin(((_92._m1.x * 4.0) * _699) + _798);
        float _815 = cos(((_92._m1.x * 3.3299999237060546875) * _699) + _798);
        float _824 = (_806 + _815) * (-_694.w);
        vec3 _832 = vec3(_806 * _691, _815 * _691, _824 * _702) * vec3(_785);
        vec3 _846 = ((_793 + _832) * _92._m0.z) * _694.z;
        vec3 _859 = _708.xyz + _846;
        _708 = vec4(_859.x, _859.y, _859.z, _708.w);
        _708.w = 1.0;
        _654.x = dot(_708, _146._m3);
        _654.y = dot(_708, _146._m4);
        _654.z = dot(_708, _146._m5);
    }
    if (_80._m2.z != 0.0)
    {
        vec4 _883 = _654;
        vec4 _885 = vec4(0.0);
        vec4 _886 = vec4(0.0);
        vec4 _887 = vec4(0.0);
        uvec4 _888 = uvec4(uint(_146._m6.x + _80._m2.x)) + uvec4(_129 * 255.0);
        if (_80._m2.z == 1.0)
        {
            uint _905 = _888.x;
            _885 = _363._m0[(_905 * 3u) + 0u];
            _886 = _363._m0[(_905 * 3u) + 1u];
            _887 = _363._m0[(_905 * 3u) + 2u];
        }
        else
        {
            float _924 = _381.w * 255.100006103515625;
            vec4 _928;
            _928.y = _924 - (floor(_924 / 128.0) * 128.0);
            float _936 = _397.w * 255.100006103515625;
            _928.z = floor(_936 / 16.0);
            _928.w = _936 - (_928.z * 16.0);
            _928.y *= 0.00393700785934925079345703125;
            _928.z *= 0.02222222276031970977783203125;
            _928.w *= 0.01666666753590106964111328125;
            _928.x = 1.0 - ((_928.y + _928.z) + _928.w);
            for (uint _972 = 0u; _972 < 4u; _972++)
            {
                _885 += (_363._m0[(_888[_972] * 3u) + 0u] * _928[_972]);
            }
            for (uint _995 = 0u; _995 < 4u; _995++)
            {
                _886 += (_363._m0[(_888[_995] * 3u) + 1u] * _928[_995]);
            }
            for (uint _1018 = 0u; _1018 < 4u; _1018++)
            {
                _887 += (_363._m0[(_888[_1018] * 3u) + 2u] * _928[_1018]);
            }
        }
        vec4 _1041 = _883;
        vec4 _1043 = _885;
        _654.x = _12(_1041, _1043);
        vec4 _1047 = _883;
        vec4 _1049 = _886;
        _654.y = _12(_1047, _1049);
        vec4 _1053 = _883;
        vec4 _1055 = _887;
        _654.z = _12(_1053, _1055);
        _654.w = 1.0;
    }
    vec4 _1061 = _654;
    vec4 _1063 = _642;
    vec4 _1060;
    _1060.x = _12(_1061, _1063);
    vec4 _1067 = _654;
    vec4 _1069 = _645;
    _1060.y = _12(_1067, _1069);
    vec4 _1073 = _654;
    vec4 _1075 = _648;
    _1060.z = _12(_1073, _1075);
    vec4 _1079 = _654;
    vec4 _1081 = _651;
    _1060.w = _12(_1079, _1081);
    _1085 = _1060;
    mat4 _1087 = mat4(vec4(_146._m8), vec4(_146._m9), vec4(_146._m10), vec4(_146._m11));
    mat4 _1121 = mat4(vec4(_92._m6), vec4(_92._m7), vec4(_92._m8), vec4(_92._m9));
    mat4 _1152 = _1087;
    mat4 _1154 = _1121;
    mat4 _1151 = _19(_1152, _1154);
    vec4 _1157 = _1151[0];
    vec4 _1160 = _1151[1];
    vec4 _1163 = _1151[2];
    vec4 _1166 = _1151[3];
    vec4 _1169 = vec4(_68.xyz, 1.0);
    bool _1178 = _80._m0.x != 0.0;
    bool _1184;
    if (_1178)
    {
        _1184 = _92._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _1184 = _1178;
    }
    bool _1190;
    if (_1184)
    {
        _1190 = _80._m1.x > 0.0;
    }
    else
    {
        _1190 = _1184;
    }
    if (_1190)
    {
        vec3 _1193 = vec3(_92._m0.xy, 0.0);
        float _1200 = _80._m0.x;
        float _1203 = _80._m0.y;
        float _1206 = _80._m0.w;
        vec4 _1209 = _129;
        float _1211 = _80._m1.x;
        float _1214 = _80._m1.y;
        float _1217 = _80._m1.z;
        float _1220 = _80._m1.w;
        vec4 _1224 = _1169;
        vec4 _1226 = _146._m0;
        vec4 _1223;
        _1223.x = _12(_1224, _1226);
        vec4 _1231 = _1169;
        vec4 _1233 = _146._m1;
        _1223.y = _12(_1231, _1233);
        vec4 _1238 = _1169;
        vec4 _1240 = _146._m2;
        _1223.z = _12(_1238, _1240);
        _1223.w = 1.0;
        float _1246 = dot(_1223.xyz, _1193) * _1211;
        float _1253 = _1209.z * _1220;
        float _1258 = _146._m0.w * _146._m1.w;
        float _1264 = ((_92._m1.x * _80._m0.z) * _1211) - _1246;
        float _1274 = (_1209.x * 1.0) - _1253;
        float _1280 = sin(_1264 - _1274);
        float _1285 = sin((_1264 * 1.33000004291534423828125) - _1274);
        float _1291 = ((_1280 + _1285) * 0.25) + 0.5;
        _1291 *= _1291;
        float _1300 = (_1291 * (_1203 - _1200)) + _1200;
        vec3 _1308 = _1193 * vec3(_1300);
        float _1313 = ((_1209.y * 16.0) - _1258) - _1253;
        float _1321 = sin(((_92._m1.x * 4.0) * _1214) + _1313);
        float _1330 = cos(((_92._m1.x * 3.3299999237060546875) * _1214) + _1313);
        float _1339 = (_1321 + _1330) * (-_1209.w);
        vec3 _1347 = vec3(_1321 * _1206, _1330 * _1206, _1339 * _1217) * vec3(_1300);
        vec3 _1361 = ((_1308 + _1347) * _92._m0.z) * _1209.z;
        vec3 _1374 = _1223.xyz + _1361;
        _1223 = vec4(_1374.x, _1374.y, _1374.z, _1223.w);
        _1223.w = 1.0;
        _1169.x = dot(_1223, _146._m3);
        _1169.y = dot(_1223, _146._m4);
        _1169.z = dot(_1223, _146._m5);
    }
    if (_80._m2.z != 0.0)
    {
        vec4 _1398 = _1169;
        vec4 _1400 = vec4(0.0);
        vec4 _1401 = vec4(0.0);
        vec4 _1402 = vec4(0.0);
        uvec4 _1403 = uvec4(uint(_146._m6.y + _80._m2.y)) + uvec4(_129 * 255.0);
        if (_80._m2.z == 1.0)
        {
            uint _1420 = _1403.x;
            _1400 = _363._m0[(_1420 * 3u) + 0u];
            _1401 = _363._m0[(_1420 * 3u) + 1u];
            _1402 = _363._m0[(_1420 * 3u) + 2u];
        }
        else
        {
            float _1439 = _381.w * 255.100006103515625;
            vec4 _1443;
            _1443.y = _1439 - (floor(_1439 / 128.0) * 128.0);
            float _1451 = _397.w * 255.100006103515625;
            _1443.z = floor(_1451 / 16.0);
            _1443.w = _1451 - (_1443.z * 16.0);
            _1443.y *= 0.00393700785934925079345703125;
            _1443.z *= 0.02222222276031970977783203125;
            _1443.w *= 0.01666666753590106964111328125;
            _1443.x = 1.0 - ((_1443.y + _1443.z) + _1443.w);
            for (uint _1487 = 0u; _1487 < 4u; _1487++)
            {
                _1400 += (_363._m0[(_1403[_1487] * 3u) + 0u] * _1443[_1487]);
            }
            for (uint _1510 = 0u; _1510 < 4u; _1510++)
            {
                _1401 += (_363._m0[(_1403[_1510] * 3u) + 1u] * _1443[_1510]);
            }
            for (uint _1533 = 0u; _1533 < 4u; _1533++)
            {
                _1402 += (_363._m0[(_1403[_1533] * 3u) + 2u] * _1443[_1533]);
            }
        }
        vec4 _1556 = _1398;
        vec4 _1558 = _1400;
        _1169.x = _12(_1556, _1558);
        vec4 _1562 = _1398;
        vec4 _1564 = _1401;
        _1169.y = _12(_1562, _1564);
        vec4 _1568 = _1398;
        vec4 _1570 = _1402;
        _1169.z = _12(_1568, _1570);
        _1169.w = 1.0;
    }
    vec4 _1576 = _1169;
    vec4 _1578 = _1157;
    vec4 _1575;
    _1575.x = _12(_1576, _1578);
    vec4 _1582 = _1169;
    vec4 _1584 = _1160;
    _1575.y = _12(_1582, _1584);
    vec4 _1588 = _1169;
    vec4 _1590 = _1163;
    _1575.z = _12(_1588, _1590);
    vec4 _1594 = _1169;
    vec4 _1596 = _1166;
    _1575.w = _12(_1594, _1596);
    _1600 = _1575;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


