// Scope 2
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _94_96
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _96;

layout(set = 1, binding = 0, std140) uniform _115_117
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _117;

layout(set = 0, binding = 1, std430) restrict readonly buffer _142_144
{
    vec4 _m0[];
} _144;

layout(set = 0, binding = 0, std140) uniform _391_393
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
} _393;

layout(set = 0, binding = 5, std430) restrict readonly buffer _959_961
{
    uint _m0[];
} _961;

layout(set = 0, binding = 6, std140) uniform _964_966
{
    vec4 _m0[4096];
} _966;

layout(set = 0, binding = 7, std140) uniform _968_970
{
    vec4 _m0[4096];
} _970;

layout(set = 0, binding = 8, std140) uniform _972_974
{
    vec4 _m0[4096];
} _974;

layout(set = 0, binding = 10, std140) uniform _980_982
{
    vec4 _m0[4096];
} _982;

layout(set = 0, binding = 11, std140) uniform _984_986
{
    vec4 _m0[4096];
} _986;

layout(set = 0, binding = 12, std140) uniform _989_991
{
    vec4 _m0[3072];
} _991;

layout(set = 0, binding = 15, std140) uniform _998_1000
{
    vec4 _m0[4095];
} _1000;

layout(push_constant, std430) uniform _955_957
{
    int _m0;
    int _m1;
} _957;

layout(set = 0, binding = 2) uniform sampler3D _755;
layout(set = 0, binding = 3) uniform sampler3D _837;
layout(set = 0, binding = 9) uniform sampler2D _978;
layout(set = 0, binding = 13) uniform samplerCubeArray _995;
layout(set = 0, binding = 14) uniform sampler2D _996;
layout(set = 0, binding = 16) uniform sampler2DShadow _1004;
layout(set = 0, binding = 17) uniform sampler3D _1005;
layout(set = 0, binding = 18) uniform sampler3D _1006;
layout(set = 0, binding = 19) uniform sampler3D _1007;
layout(set = 0, binding = 20) uniform sampler2D _1008;
layout(set = 2, binding = 1) uniform sampler2D _1009;
layout(set = 2, binding = 2) uniform sampler2D _1010;
layout(set = 2, binding = 3) uniform sampler2D _1011;

layout(location = 0) in vec4 _59;
layout(location = 2) in vec4 _67;
layout(location = 9) in vec4 _74;
layout(location = 3) in vec4 _125;
layout(location = 3) out vec4 _471;
layout(location = 4) out vec4 _495;
layout(location = 5) out vec4 _518;
layout(location = 6) out vec4 _564;
layout(location = 1) in vec2 _572;
layout(location = 12) in vec2 _574;
layout(location = 2) out vec4 _581;
layout(location = 10) out vec4 _593;
layout(location = 11) out vec4 _594;
layout(location = 12) out vec4 _595;

float _22(vec4 _20, vec4 _21)
{
    return dot(_20, _21);
}

float _18(vec4 _16, vec4 _17)
{
    return dot(_16.xyz, _17.xyz);
}

mat4 _29(mat4 _27, mat4 _28)
{
    return _27 * _28;
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

void main()
{
    vec4 _56 = vec4(0.0);
    _56 = vec4(_59.xyz, 1.0);
    vec4 _66 = (_67 * 2.0) - vec4(1.0);
    vec4 _73 = (_74 * 2.0) - vec4(1.0);
    _73.w = (floor((_74.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _93 = 0.0;
    if (_96._m0.z != 0.0)
    {
        vec4 _107 = _56;
        vec4 _109 = vec4(0.0);
        vec4 _110 = vec4(0.0);
        vec4 _111 = vec4(0.0);
        uvec4 _114 = uvec4(uint(_117._m0.x + _96._m0.x)) + uvec4(_125 * 255.0);
        if (_96._m0.z == 1.0)
        {
            uint _138 = _114.x;
            _109 = _144._m0[(_138 * 3u) + 0u];
            _110 = _144._m0[(_138 * 3u) + 1u];
            _111 = _144._m0[(_138 * 3u) + 2u];
        }
        else
        {
            float _163 = _74.w * 255.100006103515625;
            vec4 _167;
            _167.y = _163 - (floor(_163 / 128.0) * 128.0);
            float _175 = _67.w * 255.100006103515625;
            _167.z = floor(_175 / 16.0);
            _167.w = _175 - (_167.z * 16.0);
            _167.y *= 0.00393700785934925079345703125;
            _167.z *= 0.02222222276031970977783203125;
            _167.w *= 0.01666666753590106964111328125;
            _167.x = 1.0 - ((_167.y + _167.z) + _167.w);
            for (uint _215 = 0u; _215 < 4u; _215++)
            {
                _109 += (_144._m0[(_114[_215] * 3u) + 0u] * _167[_215]);
            }
            for (uint _240 = 0u; _240 < 4u; _240++)
            {
                _110 += (_144._m0[(_114[_240] * 3u) + 1u] * _167[_240]);
            }
            for (uint _263 = 0u; _263 < 4u; _263++)
            {
                _111 += (_144._m0[(_114[_263] * 3u) + 2u] * _167[_263]);
            }
        }
        vec4 _286 = _107;
        vec4 _288 = _109;
        _56.x = _22(_286, _288);
        vec4 _292 = _107;
        vec4 _294 = _110;
        _56.y = _22(_292, _294);
        vec4 _298 = _107;
        vec4 _300 = _111;
        _56.z = _22(_298, _300);
        _56.w = 1.0;
        vec4 _305 = _66;
        vec4 _307 = _305;
        vec4 _309 = _109;
        _66.x = _18(_307, _309);
        vec4 _313 = _305;
        vec4 _315 = _110;
        _66.y = _18(_313, _315);
        vec4 _319 = _305;
        vec4 _321 = _111;
        _66.z = _18(_319, _321);
        vec4 _325 = _73;
        vec4 _327 = _325;
        vec4 _329 = _109;
        _73.x = _18(_327, _329);
        vec4 _333 = _325;
        vec4 _335 = _110;
        _73.y = _18(_333, _335);
        vec4 _339 = _325;
        vec4 _341 = _111;
        _73.z = _18(_339, _341);
    }
    vec3 _353 = cross(_66.xyz, _73.xyz) * _73.w;
    vec4 _345;
    _345 = vec4(_353.x, _353.y, _353.z, _345.w);
    _345.w = 0.0;
    mat4 _357 = mat4(vec4(_117._m1), vec4(_117._m2), vec4(_117._m3), vec4(_117._m4));
    mat4 _390 = mat4(vec4(_393._m0), vec4(_393._m1), vec4(_393._m2), vec4(_393._m3));
    mat4 _424 = _357;
    mat4 _426 = _390;
    mat4 _423 = _29(_424, _426);
    vec4 _429 = _423[0];
    vec4 _432 = _423[1];
    vec4 _435 = _423[2];
    vec4 _438 = _423[3];
    vec4 _445 = _56;
    vec4 _447 = _429;
    gl_Position.x = _22(_445, _447);
    vec4 _452 = _56;
    vec4 _454 = _432;
    gl_Position.y = _22(_452, _454);
    vec4 _458 = _56;
    vec4 _460 = _435;
    gl_Position.z = _22(_458, _460);
    vec4 _464 = _56;
    vec4 _466 = _438;
    gl_Position.w = _22(_464, _466);
    vec4 _472 = _73;
    vec4 _474 = _117._m1;
    _471.x = _18(_472, _474);
    vec4 _479 = _345;
    vec4 _481 = _117._m1;
    _471.y = _18(_479, _481);
    vec4 _486 = _66;
    vec4 _488 = _117._m1;
    _471.z = _18(_486, _488);
    _471.w = _93;
    vec4 _496 = _73;
    vec4 _498 = _117._m2;
    _495.x = _18(_496, _498);
    vec4 _503 = _345;
    vec4 _505 = _117._m2;
    _495.y = _18(_503, _505);
    vec4 _510 = _66;
    vec4 _512 = _117._m2;
    _495.z = _18(_510, _512);
    _495.w = 0.0;
    vec4 _519 = _73;
    vec4 _521 = _117._m3;
    _518.x = _18(_519, _521);
    vec4 _526 = _345;
    vec4 _528 = _117._m3;
    _518.y = _18(_526, _528);
    vec4 _533 = _66;
    vec4 _535 = _117._m3;
    _518.z = _18(_533, _535);
    _518.w = 0.0;
    vec4 _542 = _56;
    vec4 _544 = _117._m1;
    vec4 _541;
    _541.x = _22(_542, _544);
    vec4 _549 = _56;
    vec4 _551 = _117._m2;
    _541.y = _22(_549, _551);
    vec4 _556 = _56;
    vec4 _558 = _117._m3;
    _541.z = _22(_556, _558);
    _541.w = 1.0;
    _564 = _541 - _393._m4;
    vec4 _569 = vec4(_572, _574);
    _581 = _569 + _96._m1;
    vec3 _586 = _564.xyz + _393._m4.xyz;
    _593 = vec4(0.0);
    _594 = vec4(0.0);
    _595 = vec4(0.0);
    float _596 = float(_393._m5.x > 0.0);
    float _602 = _393._m5.x * _117._m5.x;
    bool _611 = _393._m5.y > 0.0;
    bool _618;
    if (!_611)
    {
        _618 = _393._m5.z > 0.0;
    }
    else
    {
        _618 = _611;
    }
    bool _625;
    if (!_618)
    {
        _625 = _393._m5.w > 0.0;
    }
    else
    {
        _625 = _618;
    }
    float _608 = float(_625);
    vec3 _627 = vec3(0.579999983310699462890625) * _393._m5.yzw;
    _593 = vec4(_393._m5.y, _393._m5.z, _393._m5.w, _627.x);
    _594 = vec4(_627.y, _627.z, _627.x, _627.y);
    _595 = vec4(_627.z, _627.x, _627.y, _627.z);
    if ((_596 > 0.0) && (_608 <= 0.0))
    {
        float _668 = -4096.0;
        float _670 = 4096.0;
        float _672 = 256.0;
        float _674 = 256.0;
        float _675 = 6.0;
        float _677 = 256.0;
        float _678 = 256.0;
        float _679 = 24.0;
        vec3 _681 = vec3(1.0 / _677, 1.0 / _678, 1.0 / _679);
        vec3 _689 = vec3(2.0 / _677, 2.0 / _678, 2.0 / _679);
        vec3 _697 = vec3(1.0 / _672, 1.0 / _674, 1.0 / _675);
        float _705 = 1.0 / (_670 - _668);
        vec3 _717 = (_586 - vec3(_668)) * _705;
        vec3 _710 = _11(_717);
        vec4 _719 = vec4(0.0);
        uvec3 _722 = uvec3(0u);
        for (uint _724 = 0u; _724 < 13u; _724++)
        {
            vec3 _733 = vec3(0.5) + floor(vec3(2.0) * _710);
            vec4 _741 = vec4(_697 * (vec3(_722) + _733), 0.0);
            _719 = textureLod(_755, _741.xyz, _741.w);
            _710 = fract(_710 * vec3(2.0));
            _722 = uvec3(_719.zyx * vec3(255.0));
            if (_719.w > 0.0)
            {
                break;
            }
        }
        uint _778 = (((uint(_719.w * 255.0) << uint(24)) | (uint(_719.z * 255.0) << uint(16))) | (uint(_719.y * 255.0) << uint(8))) | uint(_719.x * 255.0);
        uvec3 _804 = uvec3((_778 >> uint(19)) & 4095u, (_778 >> uint(7)) & 4095u, _778 & 127u);
        vec3 _818 = vec3(2.0) * ((_710 * vec3(0.5)) + vec3(0.25));
        vec4 _825 = vec4(_681 * (vec3(_804) + _818), 0.0);
        vec4 _836 = textureLod(_837, vec4(_825.xy, _825.z + (_689.z * 0.0), 0.0).xyz, vec4(_825.xy, _825.z + (_689.z * 0.0), 0.0).w) * _602;
        vec4 _866 = textureLod(_837, vec4(_825.xy, _825.z + (_689.z * 1.0), 0.0).xyz, vec4(_825.xy, _825.z + (_689.z * 1.0), 0.0).w) * _602;
        vec4 _895 = textureLod(_837, vec4(_825.xy, _825.z + (_689.z * 2.0), 0.0).xyz, vec4(_825.xy, _825.z + (_689.z * 2.0), 0.0).w) * _602;
        _593 = vec4(_836.x, _866.x, _895.x, _836.y);
        _594 = vec4(_866.y, _895.y, _836.z, _866.z);
        _595 = vec4(_895.z, _836.w, _866.w, _895.w);
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}



