
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 1, binding = 0, std140) uniform _55_57
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _57;

layout(set = 0, binding = 0, std140) uniform _94_96
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _96;

layout(set = 2, binding = 0, std140) uniform _153_155
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _155;

layout(set = 0, binding = 1, std430) restrict readonly buffer _199_201
{
    vec4 _m0[];
} _201;

layout(push_constant, std430) uniform _818_820
{
    int _m0;
    int _m1;
} _820;

layout(set = 2, binding = 1) uniform sampler2D _824;
layout(set = 2, binding = 2) uniform sampler2D _825;

layout(location = 0) in vec4 _146;
layout(location = 3) in vec4 _182;
layout(location = 9) in vec4 _221;
layout(location = 2) in vec4 _237;
layout(location = 2) out vec4 _396;
layout(location = 1) in vec2 _399;
layout(location = 4) in vec2 _404;
layout(location = 12) in vec2 _802;
layout(location = 3) out vec4 _809;

mat4 _28(mat4 _26, mat4 _27)
{
    return _26 * _27;
}

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

float _17(vec4 _15, vec4 _16)
{
    return dot(_15.xyz, _16.xyz);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    mat4 _54 = mat4(vec4(_57._m0), vec4(_57._m1), vec4(_57._m2), vec4(_57._m3));
    mat4 _93 = mat4(vec4(_96._m0), vec4(_96._m1), vec4(_96._m2), vec4(_96._m3));
    mat4 _127 = _54;
    mat4 _129 = _93;
    mat4 _126 = _28(_127, _129);
    vec4 _132 = _126[0];
    vec4 _135 = _126[1];
    vec4 _138 = _126[2];
    vec4 _141 = _126[3];
    vec4 _144 = vec4(_146.xyz, 1.0);
    if (_155._m0.z != 0.0)
    {
        vec4 _165 = _144;
        vec4 _167 = vec4(0.0);
        vec4 _169 = vec4(0.0);
        vec4 _170 = vec4(0.0);
        uvec4 _173 = uvec4(uint(_57._m4.x + _155._m0.x)) + uvec4(_182 * 255.0);
        if (_155._m0.z == 1.0)
        {
            uint _195 = _173.x;
            _167 = _201._m0[(_195 * 3u) + 0u];
            _169 = _201._m0[(_195 * 3u) + 1u];
            _170 = _201._m0[(_195 * 3u) + 2u];
        }
        else
        {
            float _220 = _221.w * 255.100006103515625;
            vec4 _227;
            _227.y = _220 - (floor(_220 / 128.0) * 128.0);
            float _236 = _237.w * 255.100006103515625;
            _227.z = floor(_236 / 16.0);
            _227.w = _236 - (_227.z * 16.0);
            _227.y *= 0.00393700785934925079345703125;
            _227.z *= 0.02222222276031970977783203125;
            _227.w *= 0.01666666753590106964111328125;
            _227.x = 1.0 - ((_227.y + _227.z) + _227.w);
            for (uint _277 = 0u; _277 < 4u; _277++)
            {
                _167 += (_201._m0[(_173[_277] * 3u) + 0u] * _227[_277]);
            }
            for (uint _301 = 0u; _301 < 4u; _301++)
            {
                _169 += (_201._m0[(_173[_301] * 3u) + 1u] * _227[_301]);
            }
            for (uint _324 = 0u; _324 < 4u; _324++)
            {
                _170 += (_201._m0[(_173[_324] * 3u) + 2u] * _227[_324]);
            }
        }
        vec4 _347 = _165;
        vec4 _349 = _167;
        _144.x = _21(_347, _349);
        vec4 _353 = _165;
        vec4 _355 = _169;
        _144.y = _21(_353, _355);
        vec4 _359 = _165;
        vec4 _361 = _170;
        _144.z = _21(_359, _361);
        _144.w = 1.0;
    }
    vec4 _370 = _144;
    vec4 _372 = _132;
    gl_Position.x = _21(_370, _372);
    vec4 _377 = _144;
    vec4 _379 = _135;
    gl_Position.y = _21(_377, _379);
    vec4 _383 = _144;
    vec4 _385 = _138;
    gl_Position.z = _21(_383, _385);
    vec4 _389 = _144;
    vec4 _391 = _141;
    gl_Position.w = _21(_389, _391);
    _396 = vec4(_399.x, _399.y, _404.x, _404.y);
    vec4 _410 = vec4(_146.xyz, 1.0);
    vec4 _417 = (_237 * 2.0) - vec4(1.0);
    vec4 _423 = (_221 * 2.0) - vec4(1.0);
    _423.w = (floor((_221.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _436 = 0.0;
    if (_155._m0.z != 0.0)
    {
        vec4 _442 = _410;
        vec4 _444 = vec4(0.0);
        vec4 _445 = vec4(0.0);
        vec4 _446 = vec4(0.0);
        uvec4 _447 = uvec4(uint(_57._m4.x + _155._m0.x)) + uvec4(_182 * 255.0);
        if (_155._m0.z == 1.0)
        {
            uint _464 = _447.x;
            _444 = _201._m0[(_464 * 3u) + 0u];
            _445 = _201._m0[(_464 * 3u) + 1u];
            _446 = _201._m0[(_464 * 3u) + 2u];
        }
        else
        {
            float _483 = _221.w * 255.100006103515625;
            vec4 _487;
            _487.y = _483 - (floor(_483 / 128.0) * 128.0);
            float _495 = _237.w * 255.100006103515625;
            _487.z = floor(_495 / 16.0);
            _487.w = _495 - (_487.z * 16.0);
            _487.y *= 0.00393700785934925079345703125;
            _487.z *= 0.02222222276031970977783203125;
            _487.w *= 0.01666666753590106964111328125;
            _487.x = 1.0 - ((_487.y + _487.z) + _487.w);
            for (uint _531 = 0u; _531 < 4u; _531++)
            {
                _444 += (_201._m0[(_447[_531] * 3u) + 0u] * _487[_531]);
            }
            for (uint _554 = 0u; _554 < 4u; _554++)
            {
                _445 += (_201._m0[(_447[_554] * 3u) + 1u] * _487[_554]);
            }
            for (uint _577 = 0u; _577 < 4u; _577++)
            {
                _446 += (_201._m0[(_447[_577] * 3u) + 2u] * _487[_577]);
            }
        }
        vec4 _600 = _442;
        vec4 _602 = _444;
        _410.x = _21(_600, _602);
        vec4 _606 = _442;
        vec4 _608 = _445;
        _410.y = _21(_606, _608);
        vec4 _612 = _442;
        vec4 _614 = _446;
        _410.z = _21(_612, _614);
        _410.w = 1.0;
        vec4 _619 = _417;
        vec4 _621 = _619;
        vec4 _623 = _444;
        _417.x = _17(_621, _623);
        vec4 _627 = _619;
        vec4 _629 = _445;
        _417.y = _17(_627, _629);
        vec4 _633 = _619;
        vec4 _635 = _446;
        _417.z = _17(_633, _635);
        vec4 _639 = _423;
        vec4 _641 = _639;
        vec4 _643 = _444;
        _423.x = _17(_641, _643);
        vec4 _647 = _639;
        vec4 _649 = _445;
        _423.y = _17(_647, _649);
        vec4 _653 = _639;
        vec4 _655 = _446;
        _423.z = _17(_653, _655);
    }
    float _659 = length(_57._m5.xyz - _410.xyz);
    float _678 = abs(_659 - _57._m6.z) / _57._m6.x;
    float _668 = 1.0 - _10(_678);
    float _681 = ((_668 * _668) * _57._m6.y) * 0.00999999977648258209228515625;
    _410 += (_417 * vec4(_681, _681, _681, 0.0));
    mat4 _698 = mat4(vec4(_57._m0), vec4(_57._m1), vec4(_57._m2), vec4(_57._m3));
    mat4 _728 = mat4(vec4(_96._m0), vec4(_96._m1), vec4(_96._m2), vec4(_96._m3));
    mat4 _759 = _698;
    mat4 _761 = _728;
    mat4 _758 = _28(_759, _761);
    vec4 _764 = _758[0];
    vec4 _767 = _758[1];
    vec4 _770 = _758[2];
    vec4 _773 = _758[3];
    vec4 _776 = _410;
    vec4 _778 = _764;
    gl_Position.x = _21(_776, _778);
    vec4 _782 = _410;
    vec4 _784 = _767;
    gl_Position.y = _21(_782, _784);
    vec4 _788 = _410;
    vec4 _790 = _770;
    gl_Position.z = _21(_788, _790);
    vec4 _794 = _410;
    vec4 _796 = _773;
    gl_Position.w = _21(_794, _796);
    vec4 _800 = vec4(_399, _802);
    _809 = _800 + _155._m1;
    gl_Position.y = -gl_Position.y;
}

